import processing.core.*; 
import processing.xml.*; 

import processing.opengl.*; 
import java.lang.reflect.Constructor; 
import com.bulletphysics.*; 
import com.bulletphysics.collision.dispatch.*; 
import com.bulletphysics.collision.shapes.*; 
import com.bulletphysics.collision.broadphase.*; 
import com.bulletphysics.dynamics.*; 
import com.bulletphysics.dynamics.constraintsolver.*; 
import com.bulletphysics.linearmath.*; 
import com.bulletphysics.util.ObjectArrayList; 
import com.bulletphysics.collision.narrowphase.PersistentManifold; 
import javax.vecmath.*; 
import java.nio.ByteBuffer; 
import java.nio.ByteOrder; 
import peasy.*; 
import peasy.org.apache.commons.math.*; 
import peasy.org.apache.commons.math.geometry.*; 
import java.util.prefs.Preferences; 
import java.awt.event.KeyAdapter; 
import java.awt.Robot; 
import javax.swing.SwingUtilities; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class BalanceBalls4r02 extends PApplet {

/*
This work is licensed under the 
Creative Commons Attribution-NonCommercial 3.0 Unported License. 
To view a copy of this license, visit 
http://creativecommons.org/licenses/by-nc/3.0/ 
or send a letter to 
Creative Commons, 
444 Castro Street, Suite 900, 
Mountain View, California, 94041, USA.

JBullet library is licensed under the ZLIB licence.
To view a copy of this license, visit 
http://zlib.net/zlib_license.html
http://jbullet.advel.cz/

PeasyCam library is licenced under the 
Apache Public License, version 2.0
To view a copy of this license, visit
http://www.apache.org/licenses/LICENSE-2.0.html
http://mrfeinberg.com/peasycam/

Geosans Light font by Manfred Klein
http://manfred-klein.ina-mar.com/

Richard Brauer -- http://www.r6753.com
*/

Cam cam;
DrawObject cseg;
PFont main, etc;
long finalTime = 0;
Preferences high;

public void keyPressed() {
  if(key == 'r' && high.get("high","")!=null) {
//    high.remove("high");
    try {
    high.removeNode();
    } catch(Throwable ex) {}
    finalTime = 0;
  }
}
public void setup() {
  size(720, 480, OPENGL);
  println("r6753.com");
  high = Preferences.userNodeForPackage(getClass());
//  size(screen.width, screen.height, OPENGL);
  hint(DISABLE_OPENGL_ERROR_REPORT);
//  removeKeyListener(this);
  noStroke();

  cam = new Cam(this, 300);
//  main = createFont("Nilland-Bold.ttf", 14);
  etc = createFont("GeosansLight.ttf", 14);
  cseg = new Start(10);
  
  try {
  finalTime = new Long(high.get("high", ""));
  } catch(Throwable ex) { finalTime = 0; }
}
public void draw() {
//  if(frameCount%120==0) println(frameRate);
  background(0);
}

public void exit(){}
public void exitImp() {
//  dispose();
  try {System.exit(0);}
  catch(Throwable e) {}
}

class NextSection extends DrawObject {
  Class nextSeg;
  int nextTime;
  
  NextSection(int in) {
    super(in);
  }
  public void done() {
    if(nextSeg != null) {
      Constructor struct = null;
      try {
        struct = 
  //        nextSeg.getConstructor(
  //          BalanceBalls2.class, int.class
  //        );
        nextSeg.getDeclaredConstructors()[0];
        cseg = (DrawObject)
          struct.newInstance(BalanceBalls4r02.this, nextTime);
      }
      catch(Throwable e) {
        e.printStackTrace();
      }
    }
  }
}

class Start extends NextSection {
  {
    nextSeg = Main.class;
  }
  Start(int in) {
    super(in);
  }    
}

public class Main extends NextSection {
  Robot robot;
  DynamicsWorld world;
  Body upperBody, lowerBody, gridBody;
  long lastMouseTime, lastSimTime, lastPlayTime, playTime;
  float rmx, rmy, prmx, prmy;
  boolean playing = true;
  boolean interacting = true;
  boolean over, esca;
  ArrayList<DrawObject> drawers;
  PGraphics ovrl;

  Main(int in) {
    super(in);
    drawers = new ArrayList();
    ovrl = createGraphics(
      round(width*.38f), round(height*.1f), JAVA2D);
//    println("Main");
    
    registerKeyEvent(this);
//    class TheKeyListener extends KeyAdapter {
//      void keyReleased(KeyEvent e) {
//        if(playing && !over && e.getKeyCode() == e.VK_ESCAPE) {
//          playing = false;
//        }
//      }
//    }
//    addKeyListener(new TheKeyListener());

    try {robot = new Robot();} 
    catch(Throwable e) {}

    CollisionConfiguration cc = 
      new DefaultCollisionConfiguration();
    world = new DiscreteDynamicsWorld(
      new CollisionDispatcher(cc),
      new AxisSweep3(
//        new Vector3f(-10000, -10000, -10000), 
//        new Vector3f(-10000, -10000, -10000),
        new Vector3f(-10, -10, -10), 
        new Vector3f(10, 10, 10), 
      1024),
      new SequentialImpulseConstraintSolver(), 
      cc
    );  
    world.setGravity(new Vector3f(0, 490, 0));
    world.setInternalTickCallback(
      new InternalTickCallback() {
        public void internalTick(DynamicsWorld world, float timeStep) {
          Dispatcher dispatch = world.getDispatcher();
          int numMan = dispatch.getNumManifolds();
          for(int a=0; a<numMan; a++) {
            PersistentManifold pm = 
              dispatch.getManifoldByIndexInternal(a);
            RigidBody ba = (RigidBody)pm.getBody0();
            RigidBody bb = (RigidBody)pm.getBody1();
            int numCon = pm.getNumContacts();
            for(int b=0; b<numCon; b++) {
              if(pm.getContactPoint(b).getDistance()<=0)
                contactCallback(ba, bb);
            }
          }
        }
      },
      null
    );
//      BulletGlobals.setContactAddedCallback(
//        new ContactAddedCallback() {
//          boolean contactAdded(
//            ManifoldPoint cp,
//            CollisionObject ca, int partIdA, int indA,
//            CollisionObject cb, int partIdB, int indB
//          ) {
//            return false;
//          }
//        }
//      );

    QuadGrid gridData = new QuadGrid(40, 40, 20, 20);
    for (int[] cur : gridData.quads) {
      for (int ind : cur) {
        PVector vect = new PVector();
        if (random(100)>80 && !gridData.centerIn(480, 480, cur)) {
          int rind = (int)random(3);
          vect = gridData.data.get(ind);
          vect.y -= new int[] {
            10, 20, 30
          }
          [rind];
        }
      }
    }
    
    int triTotal = gridData.ww*gridData.hh*2;
    ByteBuffer dataBuffer = 
      ByteBuffer.allocateDirect(gridData.data.size()*12).
      order(ByteOrder.nativeOrder());
    for(PVector cur : gridData.data) {
      dataBuffer.putFloat(cur.x);
      dataBuffer.putFloat(cur.y);
      dataBuffer.putFloat(cur.z);
    }
    ByteBuffer indBuffer =
      ByteBuffer.allocateDirect(triTotal*12).
      order(ByteOrder.nativeOrder());
    for(int cur : gridData.triInds()) {
      indBuffer.putInt(cur);
    }
    TriangleIndexVertexArray tiva =
      new TriangleIndexVertexArray(
        triTotal, indBuffer, 12,
        gridData.data.size(), dataBuffer, 12
      );
    gridBody = new Body(
      world, new BvhTriangleMeshShape(tiva, true), 0, null, 
      false
    );
    gridBody.setRestitution(.5f);
    gridBody.setFriction(.5f);
    
    final QuadGrid fqg = gridData;
    DrawObject gridDraw = new DrawObject() {
      public void disp() {
        noStroke();
        beginShape(QUADS);
        int clr = 0;
        for (int[] cur : fqg.quads) {
          clr++;
          if (clr%(fqg.ww+1)==0) clr++;
          fill(
          new int[] {
            color(128, 255, 128), color(164, 255, 164)
          }
          [clr%2]
            );
          for (int ind : cur) {
            PVector vert = fqg.data.get(ind);
            vertex(vert.x, vert.y, vert.z);
          }
        }
        endShape();
      }
    };
    gridBody.addUsing(gridDraw);
    drawers.add(gridDraw);
    
    class DrawSphere extends DrawObject {
      Body body;
      int rad;
      int fil = color(255); 
      int stk = color(0);

      DrawSphere(Body body, int rad) {
        this.body = body;
        this.rad = rad;
      }

      public void disp() {
        noStroke();
        fill(fil);
        pushMatrix();
        Vector3f pos = body.getPos();
        Matrix3f rot = body.getBasis();
        translate(pos.x, pos.y, pos.z);
        applyMatrix(
          rot.m00, rot.m01, rot.m02, 0,
          rot.m10, rot.m11, rot.m12, 0,
          rot.m20, rot.m21, rot.m22, 0,
          0, 0, 0, 1);
        sphere(rad);
        pushMatrix();
        noFill();
        stroke(stk);
        float diam = rad*2+.25f;
        ellipse(0,0,diam,diam);
        rotateY(HALF_PI);
        ellipse(0,0,diam,diam);
        rotateX(HALF_PI);
        ellipse(0,0,diam,diam);
        popMatrix();
        popMatrix();
      }
    }

    lowerBody = new Body(
      world, new SphereShape(50), 1, 
      new Vector3f(0, -100, 0));
    lowerBody.setRestitution(.5f);
    lowerBody.setFriction(.5f);
    lowerBody.addUsing(new DrawSphere(lowerBody, 50));
    drawers.add(lowerBody.drawer);
    
    upperBody = new Body(
      world, new SphereShape(40), 5,
      new Vector3f(random(-1,1),-200,random(-1,1)));
    upperBody.setRestitution(.9f);
    upperBody.setFriction(.5f);
    upperBody.setCollisionFlags(
      upperBody.getCollisionFlags() |
      CollisionFlags.CUSTOM_MATERIAL_CALLBACK);
    upperBody.addUsing(new DrawSphere(upperBody, 40));
    drawers.add(upperBody.drawer);
    
    playTime = 0;
    lastPlayTime = elapsed();
    lastMouseTime = elapsed();
    lastSimTime = elapsed();
    requestFocusInWindow();
  } //Main Constructor

  public void disp() {
    if(!focused && !over) playing = false;
    if(!playing) {
      if(!esca && mousePressed) {
        lastMouseTime = elapsed();
        lastPlayTime = elapsed();
        lastSimTime = elapsed();
        playing = true;
      } else if(!mousePressed) {
        esca = false;
      }
    }
    
    if(!over) cam.camlight(255, .03f);
    Vector3f upos = upperBody.getPos();
    Vector3f lpos = lowerBody.getPos();
    
    if(playing) {
      noCursor();
      world.stepSimulation((elapsed()-lastSimTime)*.001f, 8);
      lastSimTime = elapsed();
      
      playTime += elapsed()-lastPlayTime;
      lastPlayTime = elapsed();
      
      if(elapsed()-lastMouseTime > 90) {
        robot.mouseMove(
          frame.getX()+BalanceBalls4r02.this.getX()+round(width*.5f),
          frame.getY()+BalanceBalls4r02.this.getY()+round(height*.5f)
        );
        rmx = mouseX!=pmouseX?rmx+mouseX-width*.5f:rmx;
        rmy = mouseY!=pmouseY?rmy+mouseY-height*.5f:rmy;
        lastMouseTime = elapsed();
      }
      
      cam.camrot(
        lpos.x-upos.x, 
        lpos.z-upos.z, 
        PI*.1f,
        new Vector3D(upos.x, upos.y, upos.z),
        .003f);
    } else {
      cam.camlight(64, .05f);
      cursor();
    }
    if(
      mousePressed && 
      (mouseX != pmouseX || mouseY != pmouseY) &&
      interacting
      ) {
      PVector one = new PVector(pmouseX, pmouseY, 0);
      PVector two = new PVector(mouseX, mouseY, 0);
      PVector deltb = PVector.sub(two, one);
      float rot = deltb.heading2D()-cam.rdir;
      float dis = dist(prmx, prmy, rmx, rmy);
      upperBody.applyImpulse(
        new Vector3f(cos(rot)*dis*.8f, 0, sin(rot)*dis*.8f),
        new Vector3f(0, -50, 0)
      );
    }
    prmx = rmx;
    prmy = rmy;
    
    if(upos.y >= 0 && interacting) {
      println(playTime);
      if(playTime > finalTime) {
        finalTime = playTime;
        high.put("high", new Long(finalTime).toString());
        try {
        high.flush();
        } catch(Throwable ex) {}
      }
      interacting = false;
      over = true;
    }
    
    if(over) {
      cam.camlight(0, .05f);
      if(cam.lightb == 0) {
        println("!");
        over = false;
        for(DrawObject cur : drawers) {
          cur.cease();
        }
        nextSeg = Start.class;
        nextTime = 10;
        cease();
      }
    } else {
      displayTime(playTime, ovrl);
    }
  }
  
  public void contactCallback(RigidBody ba, RigidBody bb) {
    if(
      ((ba == gridBody && bb == upperBody) ||
      (ba == upperBody && bb == gridBody)) && interacting
      ) {
        println(playTime);
        if(playTime > finalTime) {
          finalTime = playTime;
          high.put("high", new Long(finalTime).toString());
          try {
          high.flush();
          } catch(Throwable ex) {}
        }
        interacting = false;
        over = true;
      }
  }
  
  public void displayTime(long playTime, PGraphics gi) {
    gi.beginDraw();
    gi.background(0,0);
    gi.scale(width*.003f);
    gi.textMode(MODEL);
    gi.textFont(etc);
    float ty = gi.textAscent()+gi.textDescent();

    String fin;
    int sec = floor(finalTime*.001f);
    int mnt = floor(sec/60);
    int rsc = sec - mnt*60;
    int mil = (int)finalTime%1000;
    fin = mnt + "'" + nf(rsc, 2) + "''" + nf(mil, 3);
    
    String play;
    sec = floor(playTime*.001f);
    mnt = floor(sec/60);
    rsc = sec - mnt*60;
    mil = (int)playTime%1000;
    play = mnt + "'" + nf(rsc, 2) + "''" + nf(mil, 3);
    
    gi.text(fin + "   " + play, 0, ty);
    gi.endDraw();
    
    cam.pc.beginHUD();
    hint(DISABLE_DEPTH_TEST);
    noStroke();
    beginShape(QUADS);
    textureMode(NORMALIZED);
    texture(gi);
    vertex(round(width*.62f),0,0, 0,0);
    vertex(width,0,0, 1,0);
    vertex(width,round(height*.1f),0, 1,1);
    vertex(round(width*.62f),round(height*.1f),0, 0,1);
    endShape();
    hint(ENABLE_DEPTH_TEST);
    cam.pc.endHUD();
  }
  
  public void keyEvent(KeyEvent e) {
    if(
      keyCode == e.VK_ESCAPE || keyCode == e.VK_PAUSE || 
      key == 'p' || key == 'P'
      ) {
      if(keyCode == e.VK_ESCAPE) exitImp();
      if(!over) {
        esca = true;
        playing = false;
      }
    }
  }
  
//    public void physcontact(
//      CollisionObject c1, CollisionObject c2
//    ) {
//      if((c1 == gridBody && c2 == upperBody) ||
//        (c1 == upperBody && c2 == gridBody)) {
//        print(".");
//      }
//    }
    
}

/*
This work is licensed under the 
Creative Commons Attribution-NonCommercial 3.0 Unported License. 
To view a copy of this license, visit 
http://creativecommons.org/licenses/by-nc/3.0/ 
or send a letter to 
Creative Commons, 
444 Castro Street, Suite 900, 
Mountain View, California, 94041, USA.

JBullet library is licensed under the ZLIB licence.
To view a copy of this license, visit 
http://zlib.net/zlib_license.html
http://jbullet.advel.cz/

PeasyCam library is licenced under the 
Apache Public License, version 2.0
To view a copy of this license, visit
http://www.apache.org/licenses/LICENSE-2.0.html
http://mrfeinberg.com/peasycam/

Geosans Light font by Manfred Klein
http://manfred-klein.ina-mar.com/

Richard Brauer -- http://www.r6753.com
*/


























/*
This work is licensed under the 
Creative Commons Attribution-NonCommercial 3.0 Unported License. 
To view a copy of this license, visit 
http://creativecommons.org/licenses/by-nc/3.0/ 
or send a letter to 
Creative Commons, 
444 Castro Street, Suite 900, 
Mountain View, California, 94041, USA.

JBullet library is licensed under the ZLIB licence.
To view a copy of this license, visit 
http://zlib.net/zlib_license.html
http://jbullet.advel.cz/

PeasyCam library is licenced under the 
Apache Public License, version 2.0
To view a copy of this license, visit
http://www.apache.org/licenses/LICENSE-2.0.html
http://mrfeinberg.com/peasycam/

Geosans Light font by Manfred Klein
http://manfred-klein.ina-mar.com/

Richard Brauer -- http://www.r6753.com
*/



public class DrawObject implements Displayable {
  DrawObject self = DrawObject.this;
  Stoppable runner;
  final long start;
  boolean done;
  
  DrawObject() {
    start = millis();
    init(0);
  }
  DrawObject(final int time) {
    start = millis();
    init(time);
  }
  
  public void init(final int time) {
    prep();
    
    runner = new Stoppable() {
      public void run() {
        registerDraw(self);
        while(time>0?millis()-start<time&&go:go) {
          try {
            sleep(time-10<0?10000:time-10);
          } catch(InterruptedException e) {go = false;}
        }
        done = true;
      }
    };
    runner.start();
//    SwingUtilities.invokeLater(
//      new Runnable() {
//        public void run() { runner.start(); }
//      }
//    );
  }
  public void prep(){}
  public void disp(){}
  public void done(){}
  public void cease() {runner.interrupt();}
  public void draw() {
    disp();
    if(done) {
      unregisterDraw(self);
      done();
    }
  }
  
  public long elapsed() {
    return millis()-start;
  }
  
  abstract class Stoppable extends Thread {
    boolean go = true;
    public abstract void run();
    public void cease() { go = false; }
  }
}

public interface Displayable {
  public void disp();
}
/*
This work is licensed under the 
Creative Commons Attribution-NonCommercial 3.0 Unported License. 
To view a copy of this license, visit 
http://creativecommons.org/licenses/by-nc/3.0/ 
or send a letter to 
Creative Commons, 
444 Castro Street, Suite 900, 
Mountain View, California, 94041, USA.

JBullet library is licensed under the ZLIB licence.
To view a copy of this license, visit 
http://zlib.net/zlib_license.html
http://jbullet.advel.cz/

PeasyCam library is licenced under the 
Apache Public License, version 2.0
To view a copy of this license, visit
http://www.apache.org/licenses/LICENSE-2.0.html
http://mrfeinberg.com/peasycam/

Geosans Light font by Manfred Klein
http://manfred-klein.ina-mar.com/

Richard Brauer -- http://www.r6753.com
*/

class Cam extends DrawObject {
  PeasyCam pc;
  PVector look, pos, delta;
  float rdir, lightb;
  boolean light = true;
  
  Cam(PApplet p5, double distance) {
    pc = new PeasyCam(p5, distance);
    pc.setResetOnDoubleClick(false);
    pc.setMouseControlled(false);
    rdir = lightb = 0;
    look = new PVector();
    pos = new PVector();
    delta = new PVector();
  }
  
  public void disp() {
    camread();
    if(light) {
      directionalLight(
        lightb,lightb,lightb, delta.x,delta.y,delta.z
      );
      pointLight(lightb*.1f,lightb*.1f,lightb*.2f, 0,-500,0);
    }
//    fill(164,196,255);
    fill(132,164,196);
    pc.beginHUD();
    rect(0,0,width,height);
    pc.endHUD();
  }
  
  public void camread() {
    look.set(pc.getLookAt());
    pos.set(pc.getPosition());
    delta = PVector.sub(look, pos);
    delta.normalize();
  }
  public void camrot(float x, float y, float ry, Vector3D look, 
    float speed
  ) {
    rdir = alerp(rdir, atan2(y, x), speed);
    pc.setState(
      new CameraState(
        new Rotation(
          RotationOrder.YXZ,
          rdir, ry, 0),
        new Vector3D(look.getX(), look.getY(), look.getZ()),
        pc.getDistance()
      ), 
      0
    );
  }
  
  public void camlight(float in, float speed) {
    lightb = alerp(lightb, in, speed);
  }
  
  public float alerp(float in, float tar, float rate) {
    if(abs(in-tar)<.001f) return tar;
    float dt = tar-in;
    return in+dt*rate;
  }
  
}
/*
This work is licensed under the 
Creative Commons Attribution-NonCommercial 3.0 Unported License. 
To view a copy of this license, visit 
http://creativecommons.org/licenses/by-nc/3.0/ 
or send a letter to 
Creative Commons, 
444 Castro Street, Suite 900, 
Mountain View, California, 94041, USA.

JBullet library is licensed under the ZLIB licence.
To view a copy of this license, visit 
http://zlib.net/zlib_license.html
http://jbullet.advel.cz/

PeasyCam library is licenced under the 
Apache Public License, version 2.0
To view a copy of this license, visit
http://www.apache.org/licenses/LICENSE-2.0.html
http://mrfeinberg.com/peasycam/

Geosans Light font by Manfred Klein
http://manfred-klein.ina-mar.com/

Richard Brauer -- http://www.r6753.com
*/

class Body extends RigidBody {
  DynamicsWorld world;
  DrawObject drawer;
  Transform wtrans;
  RigidBodyConstructionInfo ci;
  
  Body(
    DynamicsWorld world, CollisionShape shp, 
    float mass, Vector3f trans
  ) {
    this(world, shp, mass, trans, true);
  }
  Body(
    DynamicsWorld world, CollisionShape shp, 
    float mass, Vector3f trans, boolean inertia
  ) {
    super(UsingCI.from(shp, mass, trans, inertia));
    this.world = world;
    wtrans = new Transform();
  }
  
  public void updateTrans() {
    wtrans = getMotionState().getWorldTransform(wtrans);
  }
  public Matrix3f getBasis() {
    updateTrans();
    return wtrans.basis;
  }
  public Vector3f getPos() {
    updateTrans();
    return wtrans.origin;
  }

  public void addUsing(DrawObject drawer) {
    this.drawer = drawer;
    world.addRigidBody(this);
  }

}

static class UsingCI {   
  public static RigidBodyConstructionInfo from(
    CollisionShape shp, float mass, Vector3f trans, 
    boolean inertia
  ) {
    Transform ctrans = new Transform();
    if(trans!=null) ctrans.origin.set(trans);
    
    Vector3f ivect = new Vector3f(0,0,0);
    if(inertia)
      shp.calculateLocalInertia(mass, ivect);
      
    DefaultMotionState dms =
      trans!=null?
        new DefaultMotionState(ctrans):
        new DefaultMotionState();
        
    return new RigidBodyConstructionInfo(mass, dms, shp, ivect);
  }
}
/*
This work is licensed under the 
Creative Commons Attribution-NonCommercial 3.0 Unported License. 
To view a copy of this license, visit 
http://creativecommons.org/licenses/by-nc/3.0/ 
or send a letter to 
Creative Commons, 
444 Castro Street, Suite 900, 
Mountain View, California, 94041, USA.

JBullet library is licensed under the ZLIB licence.
To view a copy of this license, visit 
http://zlib.net/zlib_license.html
http://jbullet.advel.cz/

PeasyCam library is licenced under the 
Apache Public License, version 2.0
To view a copy of this license, visit
http://www.apache.org/licenses/LICENSE-2.0.html
http://mrfeinberg.com/peasycam/

Geosans Light font by Manfred Klein
http://manfred-klein.ina-mar.com/

Richard Brauer -- http://www.r6753.com
*/

class QuadGrid {
  ArrayList<PVector> data;
  ArrayList<int[]> quads;
  float cellw, cellh;
  int ww, hh, vv;
  
  QuadGrid(float cellw, float cellh, int ww, int hh) {
    this.cellw = cellw;
    this.cellh = cellh;
    this.ww = ww;
    this.hh = hh;
    vv = (ww+1)*(hh+1);
    data = new ArrayList();
    quads = new ArrayList();
    
    init();
  }
  
  public void init() {
    float startx = -cellw*ww*.5f;
    float startz = -cellh*hh*.5f;
    int row = 0;
    int col = 0;
    
    for(int a=0; a<vv; a++) {
      if(a<(ww+1)*hh && row!=ww-1) {
        quads.add(
          new int[]{a, a+1, a+ww+2, a+ww+1}
        );
      }
      row = a%(ww+1);
      col = floor(a/(ww+1));
      data.add(new PVector(startx+cellw*row, 0, startz+cellh*col));
    }
  }
  
  public boolean centerIn(float ww, float hh, int[] qind) {
    float cx = 0;
    float cz = 0;
    for(int ind : qind) {
      PVector cur = data.get(ind);
      cx += cur.x;
      cz += cur.z;
    }
    cx *= .25f;
    cz *= .25f;
    return cx>-ww*.5f && cx<ww*.5f && cz>-hh*.5f && cz<hh*.5f;
  }
  
  public int[] triInds() {
    int[] ret = new int[0];
    for(int[] cur : quads) {
      ret = (int[])append(ret, cur[0]);
      ret = (int[])append(ret, cur[1]);
      ret = (int[])append(ret, cur[2]);
      ret = (int[])append(ret, cur[2]);
      ret = (int[])append(ret, cur[3]);
      ret = (int[])append(ret, cur[0]);
    }
    return ret;
  }

}
/*
This work is licensed under the 
Creative Commons Attribution-NonCommercial 3.0 Unported License. 
To view a copy of this license, visit 
http://creativecommons.org/licenses/by-nc/3.0/ 
or send a letter to 
Creative Commons, 
444 Castro Street, Suite 900, 
Mountain View, California, 94041, USA.

JBullet library is licensed under the ZLIB licence.
To view a copy of this license, visit 
http://zlib.net/zlib_license.html
http://jbullet.advel.cz/

PeasyCam library is licenced under the 
Apache Public License, version 2.0
To view a copy of this license, visit
http://www.apache.org/licenses/LICENSE-2.0.html
http://mrfeinberg.com/peasycam/

Geosans Light font by Manfred Klein
http://manfred-klein.ina-mar.com/

Richard Brauer -- http://www.r6753.com
*/

//http://www.bulletphysics.org/mediawiki-1.5.8/index.php/Collision_Callbacks_and_Triggers
//      Body floorBody = new Body(
//        world, new BoxShape(new Vector3f(500,5,500)), 0, null);
//      floorBody.setRestitution(.5);
//      floorBody.setFriction(.2);
//      floorBody.addUsing(new DrawObject() {
//        public void disp() {
//          noStroke();
//          fill(255);
//          beginShape(QUADS);
//          vertex(-500,-5,-500);
//          vertex(500,-5,-500);
//          vertex(500,-5,500);
//          vertex(-500,-5,500);
//          endShape();
//        }
//      });
  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#F0F0F0", "BalanceBalls4r02" });
  }
}
